#!/usr/bin/env python
# Copyright 2010-2011 Leigh L. Klotz, Jr. See file COPYRIGHT

import urllib2
from cache import CacheHandler
from lxml import etree
from config import Config

CONFIG=Config()
# lat, lon, appid
GEOCODE_URI="http://where.yahooapis.com/geocode?q=%s,%s&gflags=R&appid=%s"

class Geocode:
    def __init__(self):
        self.opener = urllib2.build_opener(CacheHandler(CONFIG.CACHE_LOCATION))

    def getreport(self, lat, lon):
        uri = GEOCODE_URI % (lat, lon, CONFIG.APPID)
        return etree.parse(self.opener.open(uri))

    def getlocation(self, lat, lon):
        return self.getlocation_string("%.9g" % (lat), "%.9g" % (lon))

    def getlocation_string(self, lat, lon):
        report = self.getreport(lat, lon)
        line1 = self.snb(report.xpath("/ResultSet/Result/line1/text()"))
        line2 = self.snb(report.xpath("/ResultSet/Result/line2/text()"))
        house = self.snb(report.xpath("/ResultSet/Result/house/text()"))
        street = self.snb(report.xpath("/ResultSet/Result/street/text()"))
        city = self.snb(report.xpath("/ResultSet/Result/city/text()"))
        result = ""
        if (line1 != ""): result = result + line1 + "\n"
        if (line2 != ""): result = result + line2 + "\n"
        if (result == ""):
            result = result + house + " " + street + "\n"
            result = result + city
        return result

    def snb(self,l):
        if len(l) > 0:
            return l[0]
        else:
            return ""
