#!/usr/bin/env python

# Copyright 2010-2011 Leigh L. Klotz, Jr. See file COPYRIGHT

import sys
from packet import Packet
from geocode import Geocode
from waypoints import Waypoints

def process():
    waypoints = Waypoints()
    u = None
    for line in sys.stdin:
        if line[0] == '#':
            continue
        data = Packet(line.rstrip('\r\n'))
        print data.getData()
        print data.getSym(), data.getSym2()
        if data.getLat() != 0 and data.getLon() != 0:
            print "---"
            print (data.getLat(), data.getLon())
            geo = Geocode().getlocation(data.getLat(), data.getLon())
            n = waypoints.lookup(geo)
            if n: print n
            print geo
            
        

if __name__ == '__main__':
    process()

