#!/usr/bin/env python
import sys
from packet import Packet

# Copyright 2010-2011 Leigh L. Klotz, Jr. See file COPYRIGHT

# markers=size:mid&markers=label:Y|37.29049,-122.15014&
starturl = "http://maps.google.com/maps/api/staticmap?size=640x566&path="
beginmark= "&markers="
endurl = "&sensor=true&maptype=roadmap"

firstpacket = None
lastpacket = None

def process(callsigns):
    global firstpacket, lastpacket
    u = None
    for line in sys.stdin:
        if line[0] == '#':
            continue
        p = Packet(line.rstrip('\r\n'))
        if p.valid:
            if len(callsigns) == 0 or p.getCall().upper() in callsigns:
                v = p.getLatLon()
                if firstpacket is None:
                    firstpacket = v
                lastpacket = v
                if u is None:
                    u = v
                else:
                    u = u + "|" + v
    if firstpacket is not None:
        u = u + beginmark + "label:A|" + firstpacket + beginmark+"|label:B|" + lastpacket
    return u

def main(callsigns):
    u = process(callsigns)
    if u is not None:
        print "%s%s%s" % (starturl, u, endurl)

if __name__ == '__main__':
    main([x.upper() for x in sys.argv[1:]])

